package org.gwtmpv.model.properties;

import java.util.List;
import java.util.Map;
import org.bindgen.Binding;
import org.bindgen.NamedBinding;
import org.bindgen.binding.AbstractBinding;
import org.bindgen.binding.GenericObjectBindingPath;
import org.gwtmpv.model.validation.Valid;
import org.gwtmpv.model.validation.ValidBindingPath;

@SuppressWarnings("all")
public abstract class PropertyBindingPath<R, P> extends AbstractBinding<R, Property<P>> {

    private ValidBindingPath<R> wasValid;
    private GenericObjectBindingPath<R,Integer> hashCodeBinding;
    private AbstractBinding<R, P> getBinding;
    private ValidBindingPath<R> touch;
    private GenericObjectBindingPath<R,String> toStringBinding;
    private Runnable reassess;
    private GenericObjectBindingPath<R,Map<Object,String>> errors;
    private GenericObjectBindingPath<R,String> name;
    private GenericObjectBindingPath<R,Boolean> readOnly;
    private GenericObjectBindingPath<R,Boolean> touched;
    private static final long serialVersionUID = 1L;

    @Override
    public String getName() {
        return "";
    }

    @Override
    public Class<?> getType() {
        return org.gwtmpv.model.properties.Property.class;
    }

    public ValidBindingPath<R> wasValid() {
        if (this.wasValid == null) {
            this.wasValid = new MyWasValidBinding();
        }
        return this.wasValid;
    }

    public GenericObjectBindingPath<R,Integer> hashCodeBinding() {
        if (this.hashCodeBinding == null) {
            this.hashCodeBinding = new MyHashCodeBindingBinding();
        }
        return this.hashCodeBinding;
    }

    public AbstractBinding<R, P> getBinding() {
        if (this.getBinding == null) {
            this.getBinding = new MyGetBindingBinding();
        }
        return this.getBinding;
    }

    public ValidBindingPath<R> touch() {
        if (this.touch == null) {
            this.touch = new MyTouchBinding();
        }
        return this.touch;
    }

    public GenericObjectBindingPath<R,String> toStringBinding() {
        if (this.toStringBinding == null) {
            this.toStringBinding = new MyToStringBindingBinding();
        }
        return this.toStringBinding;
    }

    public Runnable reassess() {
        if (this.reassess == null) {
            this.reassess = new MyReassessBinding();
        }
        return this.reassess;
    }

    public GenericObjectBindingPath<R,Map<Object,String>> errors() {
        if (this.errors == null) {
            this.errors = new MyErrorsBinding();
        }
        return this.errors;
    }

    public GenericObjectBindingPath<R,String> name() {
        if (this.name == null) {
            this.name = new MyNameBinding();
        }
        return this.name;
    }

    public GenericObjectBindingPath<R,Boolean> readOnly() {
        if (this.readOnly == null) {
            this.readOnly = new MyReadOnlyBinding();
        }
        return this.readOnly;
    }

    public GenericObjectBindingPath<R,Boolean> touched() {
        if (this.touched == null) {
            this.touched = new MyTouchedBinding();
        }
        return this.touched;
    }

    @Override
    public List<Binding<?>> getChildBindings() {
        List<Binding<?>> bindings = new java.util.ArrayList<Binding<?>>();
        bindings.add(this.wasValid());
        bindings.add(this.hashCodeBinding());
        bindings.add(this.getBinding());
        bindings.add(this.touch());
        bindings.add(this.toStringBinding());
        bindings.add(this.errors());
        bindings.add(this.name());
        bindings.add(this.readOnly());
        bindings.add(this.touched());
        return bindings;
    }

    public class MyWasValidBinding extends ValidBindingPath<R> {
        private static final long serialVersionUID = 1L;
        @Override
        public String getName() {
            return "wasValid";
        }
        @Override
        public Binding<?> getParentBinding() {
            return PropertyBindingPath.this;
        }
        @Override
        public Valid get() {
            return PropertyBindingPath.this.get().wasValid();
        }
        @Override
        public Valid getWithRoot(R root) {
            return PropertyBindingPath.this.getWithRoot(root).wasValid();
        }
        @Override
        public Valid getSafelyWithRoot(R root) {
            if (PropertyBindingPath.this.getSafelyWithRoot(root) == null) {
                return null;
            } else {
                return PropertyBindingPath.this.getWithRoot(root).wasValid();
            }
        }
        @Override
        public void set(Valid wasValid) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        @Override
        public void setWithRoot(R root, Valid wasValid) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        public boolean getBindingIsReadOnly() {
            return true;
        }
    }

    public class MyHashCodeBindingBinding extends GenericObjectBindingPath<R,Integer> {
        private static final long serialVersionUID = 1L;
        public Class<?> getType() {
            return java.lang.Integer.class;
        }
        @Override
        public String getName() {
            return "hashCodeBinding";
        }
        @Override
        public Binding<?> getParentBinding() {
            return PropertyBindingPath.this;
        }
        @Override
        public Integer get() {
            return PropertyBindingPath.this.get().hashCode();
        }
        @Override
        public Integer getWithRoot(R root) {
            return PropertyBindingPath.this.getWithRoot(root).hashCode();
        }
        @Override
        public Integer getSafelyWithRoot(R root) {
            if (PropertyBindingPath.this.getSafelyWithRoot(root) == null) {
                return null;
            } else {
                return PropertyBindingPath.this.getWithRoot(root).hashCode();
            }
        }
        @Override
        public void set(Integer hashCodeBinding) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        @Override
        public void setWithRoot(R root, Integer hashCodeBinding) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        public boolean getBindingIsReadOnly() {
            return true;
        }
    }

    public class MyGetBindingBinding extends AbstractBinding<R, P> {
        private static final long serialVersionUID = 1L;
        public Class<?> getType() {
            return null;
        }
        @Override
        public String getName() {
            return "getBinding";
        }
        @Override
        public Binding<?> getParentBinding() {
            return PropertyBindingPath.this;
        }
        @Override
        public P get() {
            return PropertyBindingPath.this.get().get();
        }
        @Override
        public P getWithRoot(R root) {
            return PropertyBindingPath.this.getWithRoot(root).get();
        }
        @Override
        public P getSafelyWithRoot(R root) {
            if (PropertyBindingPath.this.getSafelyWithRoot(root) == null) {
                return null;
            } else {
                return PropertyBindingPath.this.getWithRoot(root).get();
            }
        }
        @Override
        public void set(P getBinding) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        @Override
        public void setWithRoot(R root, P getBinding) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        public boolean getBindingIsReadOnly() {
            return true;
        }
    }

    public class MyTouchBinding extends ValidBindingPath<R> {
        private static final long serialVersionUID = 1L;
        @Override
        public String getName() {
            return "touch";
        }
        @Override
        public Binding<?> getParentBinding() {
            return PropertyBindingPath.this;
        }
        @Override
        public Valid get() {
            return PropertyBindingPath.this.get().touch();
        }
        @Override
        public Valid getWithRoot(R root) {
            return PropertyBindingPath.this.getWithRoot(root).touch();
        }
        @Override
        public Valid getSafelyWithRoot(R root) {
            if (PropertyBindingPath.this.getSafelyWithRoot(root) == null) {
                return null;
            } else {
                return PropertyBindingPath.this.getWithRoot(root).touch();
            }
        }
        @Override
        public void set(Valid touch) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        @Override
        public void setWithRoot(R root, Valid touch) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        public boolean getBindingIsReadOnly() {
            return true;
        }
    }

    public class MyToStringBindingBinding extends GenericObjectBindingPath<R,String> {
        private static final long serialVersionUID = 1L;
        public Class<?> getType() {
            return java.lang.String.class;
        }
        @Override
        public String getName() {
            return "toStringBinding";
        }
        @Override
        public Binding<?> getParentBinding() {
            return PropertyBindingPath.this;
        }
        @Override
        public String get() {
            return PropertyBindingPath.this.get().toString();
        }
        @Override
        public String getWithRoot(R root) {
            return PropertyBindingPath.this.getWithRoot(root).toString();
        }
        @Override
        public String getSafelyWithRoot(R root) {
            if (PropertyBindingPath.this.getSafelyWithRoot(root) == null) {
                return null;
            } else {
                return PropertyBindingPath.this.getWithRoot(root).toString();
            }
        }
        @Override
        public void set(String toStringBinding) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        @Override
        public void setWithRoot(R root, String toStringBinding) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        public boolean getBindingIsReadOnly() {
            return true;
        }
    }

    public class MyReassessBinding implements Runnable, NamedBinding {
        private static final long serialVersionUID = 1L;
        public void run() {
            PropertyBindingPath.this.get().reassess();
        }
        public String getName() {
            return "reassess";
        }
    }

    public class MyErrorsBinding extends GenericObjectBindingPath<R,Map<Object,String>> {
        private static final long serialVersionUID = 1L;
        public Class<?> getType() {
            return java.util.Map.class;
        }
        @Override
        public String getName() {
            return "errors";
        }
        @Override
        public Binding<?> getParentBinding() {
            return PropertyBindingPath.this;
        }
        @Override
        public Map<Object,String> get() {
            return PropertyBindingPath.this.get().getErrors();
        }
        @Override
        public Map<Object,String> getWithRoot(R root) {
            return PropertyBindingPath.this.getWithRoot(root).getErrors();
        }
        @Override
        public Map<Object,String> getSafelyWithRoot(R root) {
            if (PropertyBindingPath.this.getSafelyWithRoot(root) == null) {
                return null;
            } else {
                return PropertyBindingPath.this.getWithRoot(root).getErrors();
            }
        }
        @Override
        public void set(Map<Object,String> errors) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        @Override
        public void setWithRoot(R root, Map<Object,String> errors) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        public boolean getBindingIsReadOnly() {
            return true;
        }
    }

    public class MyNameBinding extends GenericObjectBindingPath<R,String> {
        private static final long serialVersionUID = 1L;
        public Class<?> getType() {
            return java.lang.String.class;
        }
        @Override
        public String getName() {
            return "name";
        }
        @Override
        public Binding<?> getParentBinding() {
            return PropertyBindingPath.this;
        }
        @Override
        public String get() {
            return PropertyBindingPath.this.get().getName();
        }
        @Override
        public String getWithRoot(R root) {
            return PropertyBindingPath.this.getWithRoot(root).getName();
        }
        @Override
        public String getSafelyWithRoot(R root) {
            if (PropertyBindingPath.this.getSafelyWithRoot(root) == null) {
                return null;
            } else {
                return PropertyBindingPath.this.getWithRoot(root).getName();
            }
        }
        @Override
        public void set(String name) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        @Override
        public void setWithRoot(R root, String name) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        public boolean getBindingIsReadOnly() {
            return true;
        }
    }

    public class MyReadOnlyBinding extends GenericObjectBindingPath<R,Boolean> {
        private static final long serialVersionUID = 1L;
        public Class<?> getType() {
            return java.lang.Boolean.class;
        }
        @Override
        public String getName() {
            return "readOnly";
        }
        @Override
        public Binding<?> getParentBinding() {
            return PropertyBindingPath.this;
        }
        @Override
        public Boolean get() {
            return PropertyBindingPath.this.get().isReadOnly();
        }
        @Override
        public Boolean getWithRoot(R root) {
            return PropertyBindingPath.this.getWithRoot(root).isReadOnly();
        }
        @Override
        public Boolean getSafelyWithRoot(R root) {
            if (PropertyBindingPath.this.getSafelyWithRoot(root) == null) {
                return null;
            } else {
                return PropertyBindingPath.this.getWithRoot(root).isReadOnly();
            }
        }
        @Override
        public void set(Boolean readOnly) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        @Override
        public void setWithRoot(R root, Boolean readOnly) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        public boolean getBindingIsReadOnly() {
            return true;
        }
    }

    public class MyTouchedBinding extends GenericObjectBindingPath<R,Boolean> {
        private static final long serialVersionUID = 1L;
        public Class<?> getType() {
            return java.lang.Boolean.class;
        }
        @Override
        public String getName() {
            return "touched";
        }
        @Override
        public Binding<?> getParentBinding() {
            return PropertyBindingPath.this;
        }
        @Override
        public Boolean get() {
            return PropertyBindingPath.this.get().isTouched();
        }
        @Override
        public Boolean getWithRoot(R root) {
            return PropertyBindingPath.this.getWithRoot(root).isTouched();
        }
        @Override
        public Boolean getSafelyWithRoot(R root) {
            if (PropertyBindingPath.this.getSafelyWithRoot(root) == null) {
                return null;
            } else {
                return PropertyBindingPath.this.getWithRoot(root).isTouched();
            }
        }
        @Override
        public void set(Boolean touched) {
            PropertyBindingPath.this.get().setTouched(touched);
        }
        @Override
        public void setWithRoot(R root, Boolean touched) {
            PropertyBindingPath.this.getWithRoot(root).setTouched(touched);
        }
    }

}
