package org.gwtmpv.model.properties;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import org.bindgen.Binding;
import org.bindgen.NamedBinding;
import org.bindgen.binding.AbstractBinding;
import org.bindgen.binding.GenericObjectBindingPath;
import org.gwtmpv.model.validation.Valid;
import org.gwtmpv.model.validation.ValidBindingPath;
import org.gwtmpv.model.values.Value;
import org.gwtmpv.model.values.ValueBindingPath;

@SuppressWarnings("all")
public abstract class PropertyGroupBindingPath<R> extends AbstractBinding<R, PropertyGroup> {

    private ValidBindingPath<R> wasValid;
    private GenericObjectBindingPath<R,Integer> hashCodeBinding;
    private GenericObjectBindingPath<R,Boolean> getBinding;
    private ValidBindingPath<R> touch;
    private GenericObjectBindingPath<R,String> toStringBinding;
    private PropertyGroupBindingPath<R> req;
    private Runnable reassess;
    private Runnable capture;
    private Runnable restore;
    private ValueBindingPath<R, Boolean> value;
    private GenericObjectBindingPath<R,Map<Object,String>> errors;
    private GenericObjectBindingPath<R,ArrayList<Property<?>>> properties;
    private GenericObjectBindingPath<R,String> name;
    private PropertyGroupBindingPath<R> getThis;
    private GenericObjectBindingPath<R,Boolean> readOnly;
    private GenericObjectBindingPath<R,Boolean> touched;
    private GenericObjectBindingPath<R,ArrayList<Property<?>>> derived;
    private static final long serialVersionUID = 1L;

    @Override
    public String getName() {
        return "";
    }

    @Override
    public Class<?> getType() {
        return org.gwtmpv.model.properties.PropertyGroup.class;
    }

    public ValidBindingPath<R> wasValid() {
        if (this.wasValid == null) {
            this.wasValid = new MyWasValidBinding();
        }
        return this.wasValid;
    }

    public GenericObjectBindingPath<R,Integer> hashCodeBinding() {
        if (this.hashCodeBinding == null) {
            this.hashCodeBinding = new MyHashCodeBindingBinding();
        }
        return this.hashCodeBinding;
    }

    public GenericObjectBindingPath<R,Boolean> getBinding() {
        if (this.getBinding == null) {
            this.getBinding = new MyGetBindingBinding();
        }
        return this.getBinding;
    }

    public ValidBindingPath<R> touch() {
        if (this.touch == null) {
            this.touch = new MyTouchBinding();
        }
        return this.touch;
    }

    public GenericObjectBindingPath<R,String> toStringBinding() {
        if (this.toStringBinding == null) {
            this.toStringBinding = new MyToStringBindingBinding();
        }
        return this.toStringBinding;
    }

    public PropertyGroupBindingPath<R> req() {
        if (this.req == null) {
            this.req = new MyReqBinding();
        }
        return this.req;
    }

    public Runnable reassess() {
        if (this.reassess == null) {
            this.reassess = new MyReassessBinding();
        }
        return this.reassess;
    }

    public Runnable capture() {
        if (this.capture == null) {
            this.capture = new MyCaptureBinding();
        }
        return this.capture;
    }

    public Runnable restore() {
        if (this.restore == null) {
            this.restore = new MyRestoreBinding();
        }
        return this.restore;
    }

    public ValueBindingPath<R, Boolean> value() {
        if (this.value == null) {
            this.value = new MyValueBinding();
        }
        return this.value;
    }

    public GenericObjectBindingPath<R,Map<Object,String>> errors() {
        if (this.errors == null) {
            this.errors = new MyErrorsBinding();
        }
        return this.errors;
    }

    public GenericObjectBindingPath<R,ArrayList<Property<?>>> properties() {
        if (this.properties == null) {
            this.properties = new MyPropertiesBinding();
        }
        return this.properties;
    }

    public GenericObjectBindingPath<R,String> name() {
        if (this.name == null) {
            this.name = new MyNameBinding();
        }
        return this.name;
    }

    protected PropertyGroupBindingPath<R> getThis() {
        if (this.getThis == null) {
            this.getThis = new MyGetThisBinding();
        }
        return this.getThis;
    }

    public GenericObjectBindingPath<R,Boolean> readOnly() {
        if (this.readOnly == null) {
            this.readOnly = new MyReadOnlyBinding();
        }
        return this.readOnly;
    }

    public GenericObjectBindingPath<R,Boolean> touched() {
        if (this.touched == null) {
            this.touched = new MyTouchedBinding();
        }
        return this.touched;
    }

    protected GenericObjectBindingPath<R,ArrayList<Property<?>>> derived() {
        if (this.derived == null) {
            this.derived = new MyDerivedBinding();
        }
        return this.derived;
    }

    @Override
    public List<Binding<?>> getChildBindings() {
        List<Binding<?>> bindings = new java.util.ArrayList<Binding<?>>();
        bindings.add(this.wasValid());
        bindings.add(this.hashCodeBinding());
        bindings.add(this.getBinding());
        bindings.add(this.touch());
        bindings.add(this.toStringBinding());
        bindings.add(this.req());
        bindings.add(this.value());
        bindings.add(this.errors());
        bindings.add(this.properties());
        bindings.add(this.name());
        bindings.add(this.getThis());
        bindings.add(this.readOnly());
        bindings.add(this.touched());
        bindings.add(this.derived());
        return bindings;
    }

    public class MyWasValidBinding extends ValidBindingPath<R> {
        private static final long serialVersionUID = 1L;
        @Override
        public String getName() {
            return "wasValid";
        }
        @Override
        public Binding<?> getParentBinding() {
            return PropertyGroupBindingPath.this;
        }
        @Override
        public Valid get() {
            return PropertyGroupBindingPath.this.get().wasValid();
        }
        @Override
        public Valid getWithRoot(R root) {
            return PropertyGroupBindingPath.this.getWithRoot(root).wasValid();
        }
        @Override
        public Valid getSafelyWithRoot(R root) {
            if (PropertyGroupBindingPath.this.getSafelyWithRoot(root) == null) {
                return null;
            } else {
                return PropertyGroupBindingPath.this.getWithRoot(root).wasValid();
            }
        }
        @Override
        public void set(Valid wasValid) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        @Override
        public void setWithRoot(R root, Valid wasValid) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        public boolean getBindingIsReadOnly() {
            return true;
        }
    }

    public class MyHashCodeBindingBinding extends GenericObjectBindingPath<R,Integer> {
        private static final long serialVersionUID = 1L;
        public Class<?> getType() {
            return java.lang.Integer.class;
        }
        @Override
        public String getName() {
            return "hashCodeBinding";
        }
        @Override
        public Binding<?> getParentBinding() {
            return PropertyGroupBindingPath.this;
        }
        @Override
        public Integer get() {
            return PropertyGroupBindingPath.this.get().hashCode();
        }
        @Override
        public Integer getWithRoot(R root) {
            return PropertyGroupBindingPath.this.getWithRoot(root).hashCode();
        }
        @Override
        public Integer getSafelyWithRoot(R root) {
            if (PropertyGroupBindingPath.this.getSafelyWithRoot(root) == null) {
                return null;
            } else {
                return PropertyGroupBindingPath.this.getWithRoot(root).hashCode();
            }
        }
        @Override
        public void set(Integer hashCodeBinding) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        @Override
        public void setWithRoot(R root, Integer hashCodeBinding) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        public boolean getBindingIsReadOnly() {
            return true;
        }
    }

    public class MyGetBindingBinding extends GenericObjectBindingPath<R,Boolean> {
        private static final long serialVersionUID = 1L;
        public Class<?> getType() {
            return java.lang.Boolean.class;
        }
        @Override
        public String getName() {
            return "getBinding";
        }
        @Override
        public Binding<?> getParentBinding() {
            return PropertyGroupBindingPath.this;
        }
        @Override
        public Boolean get() {
            return PropertyGroupBindingPath.this.get().get();
        }
        @Override
        public Boolean getWithRoot(R root) {
            return PropertyGroupBindingPath.this.getWithRoot(root).get();
        }
        @Override
        public Boolean getSafelyWithRoot(R root) {
            if (PropertyGroupBindingPath.this.getSafelyWithRoot(root) == null) {
                return null;
            } else {
                return PropertyGroupBindingPath.this.getWithRoot(root).get();
            }
        }
        @Override
        public void set(Boolean getBinding) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        @Override
        public void setWithRoot(R root, Boolean getBinding) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        public boolean getBindingIsReadOnly() {
            return true;
        }
    }

    public class MyTouchBinding extends ValidBindingPath<R> {
        private static final long serialVersionUID = 1L;
        @Override
        public String getName() {
            return "touch";
        }
        @Override
        public Binding<?> getParentBinding() {
            return PropertyGroupBindingPath.this;
        }
        @Override
        public Valid get() {
            return PropertyGroupBindingPath.this.get().touch();
        }
        @Override
        public Valid getWithRoot(R root) {
            return PropertyGroupBindingPath.this.getWithRoot(root).touch();
        }
        @Override
        public Valid getSafelyWithRoot(R root) {
            if (PropertyGroupBindingPath.this.getSafelyWithRoot(root) == null) {
                return null;
            } else {
                return PropertyGroupBindingPath.this.getWithRoot(root).touch();
            }
        }
        @Override
        public void set(Valid touch) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        @Override
        public void setWithRoot(R root, Valid touch) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        public boolean getBindingIsReadOnly() {
            return true;
        }
    }

    public class MyToStringBindingBinding extends GenericObjectBindingPath<R,String> {
        private static final long serialVersionUID = 1L;
        public Class<?> getType() {
            return java.lang.String.class;
        }
        @Override
        public String getName() {
            return "toStringBinding";
        }
        @Override
        public Binding<?> getParentBinding() {
            return PropertyGroupBindingPath.this;
        }
        @Override
        public String get() {
            return PropertyGroupBindingPath.this.get().toString();
        }
        @Override
        public String getWithRoot(R root) {
            return PropertyGroupBindingPath.this.getWithRoot(root).toString();
        }
        @Override
        public String getSafelyWithRoot(R root) {
            if (PropertyGroupBindingPath.this.getSafelyWithRoot(root) == null) {
                return null;
            } else {
                return PropertyGroupBindingPath.this.getWithRoot(root).toString();
            }
        }
        @Override
        public void set(String toStringBinding) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        @Override
        public void setWithRoot(R root, String toStringBinding) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        public boolean getBindingIsReadOnly() {
            return true;
        }
    }

    public class MyReqBinding extends PropertyGroupBindingPath<R> {
        private static final long serialVersionUID = 1L;
        @Override
        public String getName() {
            return "req";
        }
        @Override
        public Binding<?> getParentBinding() {
            return PropertyGroupBindingPath.this;
        }
        @Override
        public PropertyGroup get() {
            return PropertyGroupBindingPath.this.get().req();
        }
        @Override
        public PropertyGroup getWithRoot(R root) {
            return PropertyGroupBindingPath.this.getWithRoot(root).req();
        }
        @Override
        public PropertyGroup getSafelyWithRoot(R root) {
            if (PropertyGroupBindingPath.this.getSafelyWithRoot(root) == null) {
                return null;
            } else {
                return PropertyGroupBindingPath.this.getWithRoot(root).req();
            }
        }
        @Override
        public void set(PropertyGroup req) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        @Override
        public void setWithRoot(R root, PropertyGroup req) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        public boolean getBindingIsReadOnly() {
            return true;
        }
    }

    public class MyReassessBinding implements Runnable, NamedBinding {
        private static final long serialVersionUID = 1L;
        public void run() {
            PropertyGroupBindingPath.this.get().reassess();
        }
        public String getName() {
            return "reassess";
        }
    }

    public class MyCaptureBinding implements Runnable, NamedBinding {
        private static final long serialVersionUID = 1L;
        public void run() {
            PropertyGroupBindingPath.this.get().capture();
        }
        public String getName() {
            return "capture";
        }
    }

    public class MyRestoreBinding implements Runnable, NamedBinding {
        private static final long serialVersionUID = 1L;
        public void run() {
            PropertyGroupBindingPath.this.get().restore();
        }
        public String getName() {
            return "restore";
        }
    }

    public class MyValueBinding extends ValueBindingPath<R, Boolean> {
        private static final long serialVersionUID = 1L;
        @Override
        public String getName() {
            return "value";
        }
        @Override
        public Binding<?> getParentBinding() {
            return PropertyGroupBindingPath.this;
        }
        @Override
        public Value<Boolean> get() {
            return PropertyGroupBindingPath.this.get().getValue();
        }
        @Override
        public Value<Boolean> getWithRoot(R root) {
            return PropertyGroupBindingPath.this.getWithRoot(root).getValue();
        }
        @Override
        public Value<Boolean> getSafelyWithRoot(R root) {
            if (PropertyGroupBindingPath.this.getSafelyWithRoot(root) == null) {
                return null;
            } else {
                return PropertyGroupBindingPath.this.getWithRoot(root).getValue();
            }
        }
        @Override
        public void set(Value<Boolean> value) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        @Override
        public void setWithRoot(R root, Value<Boolean> value) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        public boolean getBindingIsReadOnly() {
            return true;
        }
    }

    public class MyErrorsBinding extends GenericObjectBindingPath<R,Map<Object,String>> {
        private static final long serialVersionUID = 1L;
        public Class<?> getType() {
            return java.util.Map.class;
        }
        @Override
        public String getName() {
            return "errors";
        }
        @Override
        public Binding<?> getParentBinding() {
            return PropertyGroupBindingPath.this;
        }
        @Override
        public Map<Object,String> get() {
            return PropertyGroupBindingPath.this.get().getErrors();
        }
        @Override
        public Map<Object,String> getWithRoot(R root) {
            return PropertyGroupBindingPath.this.getWithRoot(root).getErrors();
        }
        @Override
        public Map<Object,String> getSafelyWithRoot(R root) {
            if (PropertyGroupBindingPath.this.getSafelyWithRoot(root) == null) {
                return null;
            } else {
                return PropertyGroupBindingPath.this.getWithRoot(root).getErrors();
            }
        }
        @Override
        public void set(Map<Object,String> errors) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        @Override
        public void setWithRoot(R root, Map<Object,String> errors) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        public boolean getBindingIsReadOnly() {
            return true;
        }
    }

    public class MyPropertiesBinding extends GenericObjectBindingPath<R,ArrayList<Property<?>>> {
        private static final long serialVersionUID = 1L;
        public Class<?> getType() {
            return java.util.ArrayList.class;
        }
        @Override
        public String getName() {
            return "properties";
        }
        @Override
        public Binding<?> getParentBinding() {
            return PropertyGroupBindingPath.this;
        }
        @Override
        public ArrayList<Property<?>> get() {
            return PropertyGroupBindingPath.this.get().getProperties();
        }
        @Override
        public ArrayList<Property<?>> getWithRoot(R root) {
            return PropertyGroupBindingPath.this.getWithRoot(root).getProperties();
        }
        @Override
        public ArrayList<Property<?>> getSafelyWithRoot(R root) {
            if (PropertyGroupBindingPath.this.getSafelyWithRoot(root) == null) {
                return null;
            } else {
                return PropertyGroupBindingPath.this.getWithRoot(root).getProperties();
            }
        }
        @Override
        public void set(ArrayList<Property<?>> properties) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        @Override
        public void setWithRoot(R root, ArrayList<Property<?>> properties) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        public boolean getBindingIsReadOnly() {
            return true;
        }
    }

    public class MyNameBinding extends GenericObjectBindingPath<R,String> {
        private static final long serialVersionUID = 1L;
        public Class<?> getType() {
            return java.lang.String.class;
        }
        @Override
        public String getName() {
            return "name";
        }
        @Override
        public Binding<?> getParentBinding() {
            return PropertyGroupBindingPath.this;
        }
        @Override
        public String get() {
            return PropertyGroupBindingPath.this.get().getName();
        }
        @Override
        public String getWithRoot(R root) {
            return PropertyGroupBindingPath.this.getWithRoot(root).getName();
        }
        @Override
        public String getSafelyWithRoot(R root) {
            if (PropertyGroupBindingPath.this.getSafelyWithRoot(root) == null) {
                return null;
            } else {
                return PropertyGroupBindingPath.this.getWithRoot(root).getName();
            }
        }
        @Override
        public void set(String name) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        @Override
        public void setWithRoot(R root, String name) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        public boolean getBindingIsReadOnly() {
            return true;
        }
    }

    protected class MyGetThisBinding extends PropertyGroupBindingPath<R> {
        private static final long serialVersionUID = 1L;
        @Override
        public String getName() {
            return "getThis";
        }
        @Override
        public Binding<?> getParentBinding() {
            return PropertyGroupBindingPath.this;
        }
        @Override
        public PropertyGroup get() {
            return PropertyGroupBindingPath.this.get().getThis();
        }
        @Override
        public PropertyGroup getWithRoot(R root) {
            return PropertyGroupBindingPath.this.getWithRoot(root).getThis();
        }
        @Override
        public PropertyGroup getSafelyWithRoot(R root) {
            if (PropertyGroupBindingPath.this.getSafelyWithRoot(root) == null) {
                return null;
            } else {
                return PropertyGroupBindingPath.this.getWithRoot(root).getThis();
            }
        }
        @Override
        public void set(PropertyGroup getThis) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        @Override
        public void setWithRoot(R root, PropertyGroup getThis) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        public boolean getBindingIsReadOnly() {
            return true;
        }
    }

    public class MyReadOnlyBinding extends GenericObjectBindingPath<R,Boolean> {
        private static final long serialVersionUID = 1L;
        public Class<?> getType() {
            return java.lang.Boolean.class;
        }
        @Override
        public String getName() {
            return "readOnly";
        }
        @Override
        public Binding<?> getParentBinding() {
            return PropertyGroupBindingPath.this;
        }
        @Override
        public Boolean get() {
            return PropertyGroupBindingPath.this.get().isReadOnly();
        }
        @Override
        public Boolean getWithRoot(R root) {
            return PropertyGroupBindingPath.this.getWithRoot(root).isReadOnly();
        }
        @Override
        public Boolean getSafelyWithRoot(R root) {
            if (PropertyGroupBindingPath.this.getSafelyWithRoot(root) == null) {
                return null;
            } else {
                return PropertyGroupBindingPath.this.getWithRoot(root).isReadOnly();
            }
        }
        @Override
        public void set(Boolean readOnly) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        @Override
        public void setWithRoot(R root, Boolean readOnly) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        public boolean getBindingIsReadOnly() {
            return true;
        }
    }

    public class MyTouchedBinding extends GenericObjectBindingPath<R,Boolean> {
        private static final long serialVersionUID = 1L;
        public Class<?> getType() {
            return java.lang.Boolean.class;
        }
        @Override
        public String getName() {
            return "touched";
        }
        @Override
        public Binding<?> getParentBinding() {
            return PropertyGroupBindingPath.this;
        }
        @Override
        public Boolean get() {
            return PropertyGroupBindingPath.this.get().isTouched();
        }
        @Override
        public Boolean getWithRoot(R root) {
            return PropertyGroupBindingPath.this.getWithRoot(root).isTouched();
        }
        @Override
        public Boolean getSafelyWithRoot(R root) {
            if (PropertyGroupBindingPath.this.getSafelyWithRoot(root) == null) {
                return null;
            } else {
                return PropertyGroupBindingPath.this.getWithRoot(root).isTouched();
            }
        }
        @Override
        public void set(Boolean touched) {
            PropertyGroupBindingPath.this.get().setTouched(touched);
        }
        @Override
        public void setWithRoot(R root, Boolean touched) {
            PropertyGroupBindingPath.this.getWithRoot(root).setTouched(touched);
        }
    }

    protected class MyDerivedBinding extends GenericObjectBindingPath<R,ArrayList<Property<?>>> {
        private static final long serialVersionUID = 1L;
        public Class<?> getType() {
            return java.util.ArrayList.class;
        }
        @Override
        public String getName() {
            return "derived";
        }
        @Override
        public Binding<?> getParentBinding() {
            return PropertyGroupBindingPath.this;
        }
        @Override
        public ArrayList<Property<?>> get() {
            return PropertyGroupBindingPath.this.get().derived;
        }
        @Override
        public ArrayList<Property<?>> getWithRoot(R root) {
            return PropertyGroupBindingPath.this.getWithRoot(root).derived;
        }
        @Override
        public ArrayList<Property<?>> getSafelyWithRoot(R root) {
            if (PropertyGroupBindingPath.this.getSafelyWithRoot(root) == null) {
                return null;
            } else {
                return PropertyGroupBindingPath.this.getSafelyWithRoot(root).derived;
            }
        }
        @Override
        public void set(ArrayList<Property<?>> derived) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        @Override
        public void setWithRoot(R root, ArrayList<Property<?>> derived) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        public boolean getBindingIsReadOnly() {
            return true;
        }
    }

}
