package org.gwtmpv.model.properties;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import org.bindgen.Binding;
import org.bindgen.NamedBinding;
import org.bindgen.binding.AbstractBinding;
import org.bindgen.binding.GenericObjectBindingPath;
import org.gwtmpv.model.validation.Valid;
import org.gwtmpv.model.validation.ValidBindingPath;
import org.gwtmpv.model.values.Value;
import org.gwtmpv.model.values.ValueBindingPath;

@SuppressWarnings("all")
public abstract class StringPropertyBindingPath<R> extends AbstractBinding<R, StringProperty> {

    private StringPropertyBindingPath<R> numeric;
    private ValidBindingPath<R> wasValid;
    private GenericObjectBindingPath<R,Integer> hashCodeBinding;
    private IntegerPropertyBindingPath<R> remaining;
    private IntegerPropertyBindingPath<R> maxLength;
    private IntegerPropertyBindingPath<R> length;
    private GenericObjectBindingPath<R,String> getBinding;
    private ValidBindingPath<R> touch;
    private GenericObjectBindingPath<R,String> toStringBinding;
    private StringPropertyBindingPath<R> req;
    private Runnable reassess;
    private ValueBindingPath<R, String> value;
    private GenericObjectBindingPath<R,Integer> getRemaining;
    private GenericObjectBindingPath<R,Integer> getMaxLength;
    private GenericObjectBindingPath<R,Map<Object,String>> errors;
    private GenericObjectBindingPath<R,String> name;
    private StringPropertyBindingPath<R> getThis;
    private GenericObjectBindingPath<R,Integer> getLength;
    private GenericObjectBindingPath<R,Boolean> readOnly;
    private GenericObjectBindingPath<R,Boolean> touched;
    private GenericObjectBindingPath<R,ArrayList<Property<?>>> derived;
    private static final long serialVersionUID = 1L;

    @Override
    public String getName() {
        return "";
    }

    @Override
    public Class<?> getType() {
        return org.gwtmpv.model.properties.StringProperty.class;
    }

    public StringPropertyBindingPath<R> numeric() {
        if (this.numeric == null) {
            this.numeric = new MyNumericBinding();
        }
        return this.numeric;
    }

    public ValidBindingPath<R> wasValid() {
        if (this.wasValid == null) {
            this.wasValid = new MyWasValidBinding();
        }
        return this.wasValid;
    }

    public GenericObjectBindingPath<R,Integer> hashCodeBinding() {
        if (this.hashCodeBinding == null) {
            this.hashCodeBinding = new MyHashCodeBindingBinding();
        }
        return this.hashCodeBinding;
    }

    public IntegerPropertyBindingPath<R> remaining() {
        if (this.remaining == null) {
            this.remaining = new MyRemainingBinding();
        }
        return this.remaining;
    }

    public IntegerPropertyBindingPath<R> maxLength() {
        if (this.maxLength == null) {
            this.maxLength = new MyMaxLengthBinding();
        }
        return this.maxLength;
    }

    public IntegerPropertyBindingPath<R> length() {
        if (this.length == null) {
            this.length = new MyLengthBinding();
        }
        return this.length;
    }

    public GenericObjectBindingPath<R,String> getBinding() {
        if (this.getBinding == null) {
            this.getBinding = new MyGetBindingBinding();
        }
        return this.getBinding;
    }

    public ValidBindingPath<R> touch() {
        if (this.touch == null) {
            this.touch = new MyTouchBinding();
        }
        return this.touch;
    }

    public GenericObjectBindingPath<R,String> toStringBinding() {
        if (this.toStringBinding == null) {
            this.toStringBinding = new MyToStringBindingBinding();
        }
        return this.toStringBinding;
    }

    public StringPropertyBindingPath<R> req() {
        if (this.req == null) {
            this.req = new MyReqBinding();
        }
        return this.req;
    }

    public Runnable reassess() {
        if (this.reassess == null) {
            this.reassess = new MyReassessBinding();
        }
        return this.reassess;
    }

    public ValueBindingPath<R, String> value() {
        if (this.value == null) {
            this.value = new MyValueBinding();
        }
        return this.value;
    }

    public GenericObjectBindingPath<R,Integer> getRemaining() {
        if (this.getRemaining == null) {
            this.getRemaining = new MyGetRemainingBinding();
        }
        return this.getRemaining;
    }

    public GenericObjectBindingPath<R,Integer> getMaxLength() {
        if (this.getMaxLength == null) {
            this.getMaxLength = new MyGetMaxLengthBinding();
        }
        return this.getMaxLength;
    }

    public GenericObjectBindingPath<R,Map<Object,String>> errors() {
        if (this.errors == null) {
            this.errors = new MyErrorsBinding();
        }
        return this.errors;
    }

    public GenericObjectBindingPath<R,String> name() {
        if (this.name == null) {
            this.name = new MyNameBinding();
        }
        return this.name;
    }

    protected StringPropertyBindingPath<R> getThis() {
        if (this.getThis == null) {
            this.getThis = new MyGetThisBinding();
        }
        return this.getThis;
    }

    public GenericObjectBindingPath<R,Integer> getLength() {
        if (this.getLength == null) {
            this.getLength = new MyGetLengthBinding();
        }
        return this.getLength;
    }

    public GenericObjectBindingPath<R,Boolean> readOnly() {
        if (this.readOnly == null) {
            this.readOnly = new MyReadOnlyBinding();
        }
        return this.readOnly;
    }

    public GenericObjectBindingPath<R,Boolean> touched() {
        if (this.touched == null) {
            this.touched = new MyTouchedBinding();
        }
        return this.touched;
    }

    protected GenericObjectBindingPath<R,ArrayList<Property<?>>> derived() {
        if (this.derived == null) {
            this.derived = new MyDerivedBinding();
        }
        return this.derived;
    }

    @Override
    public List<Binding<?>> getChildBindings() {
        List<Binding<?>> bindings = new java.util.ArrayList<Binding<?>>();
        bindings.add(this.numeric());
        bindings.add(this.wasValid());
        bindings.add(this.hashCodeBinding());
        bindings.add(this.remaining());
        bindings.add(this.maxLength());
        bindings.add(this.length());
        bindings.add(this.getBinding());
        bindings.add(this.touch());
        bindings.add(this.toStringBinding());
        bindings.add(this.req());
        bindings.add(this.value());
        bindings.add(this.getRemaining());
        bindings.add(this.getMaxLength());
        bindings.add(this.errors());
        bindings.add(this.name());
        bindings.add(this.getThis());
        bindings.add(this.getLength());
        bindings.add(this.readOnly());
        bindings.add(this.touched());
        bindings.add(this.derived());
        return bindings;
    }

    public class MyNumericBinding extends StringPropertyBindingPath<R> {
        private static final long serialVersionUID = 1L;
        @Override
        public String getName() {
            return "numeric";
        }
        @Override
        public Binding<?> getParentBinding() {
            return StringPropertyBindingPath.this;
        }
        @Override
        public StringProperty get() {
            return StringPropertyBindingPath.this.get().numeric();
        }
        @Override
        public StringProperty getWithRoot(R root) {
            return StringPropertyBindingPath.this.getWithRoot(root).numeric();
        }
        @Override
        public StringProperty getSafelyWithRoot(R root) {
            if (StringPropertyBindingPath.this.getSafelyWithRoot(root) == null) {
                return null;
            } else {
                return StringPropertyBindingPath.this.getWithRoot(root).numeric();
            }
        }
        @Override
        public void set(StringProperty numeric) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        @Override
        public void setWithRoot(R root, StringProperty numeric) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        public boolean getBindingIsReadOnly() {
            return true;
        }
    }

    public class MyWasValidBinding extends ValidBindingPath<R> {
        private static final long serialVersionUID = 1L;
        @Override
        public String getName() {
            return "wasValid";
        }
        @Override
        public Binding<?> getParentBinding() {
            return StringPropertyBindingPath.this;
        }
        @Override
        public Valid get() {
            return StringPropertyBindingPath.this.get().wasValid();
        }
        @Override
        public Valid getWithRoot(R root) {
            return StringPropertyBindingPath.this.getWithRoot(root).wasValid();
        }
        @Override
        public Valid getSafelyWithRoot(R root) {
            if (StringPropertyBindingPath.this.getSafelyWithRoot(root) == null) {
                return null;
            } else {
                return StringPropertyBindingPath.this.getWithRoot(root).wasValid();
            }
        }
        @Override
        public void set(Valid wasValid) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        @Override
        public void setWithRoot(R root, Valid wasValid) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        public boolean getBindingIsReadOnly() {
            return true;
        }
    }

    public class MyHashCodeBindingBinding extends GenericObjectBindingPath<R,Integer> {
        private static final long serialVersionUID = 1L;
        public Class<?> getType() {
            return java.lang.Integer.class;
        }
        @Override
        public String getName() {
            return "hashCodeBinding";
        }
        @Override
        public Binding<?> getParentBinding() {
            return StringPropertyBindingPath.this;
        }
        @Override
        public Integer get() {
            return StringPropertyBindingPath.this.get().hashCode();
        }
        @Override
        public Integer getWithRoot(R root) {
            return StringPropertyBindingPath.this.getWithRoot(root).hashCode();
        }
        @Override
        public Integer getSafelyWithRoot(R root) {
            if (StringPropertyBindingPath.this.getSafelyWithRoot(root) == null) {
                return null;
            } else {
                return StringPropertyBindingPath.this.getWithRoot(root).hashCode();
            }
        }
        @Override
        public void set(Integer hashCodeBinding) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        @Override
        public void setWithRoot(R root, Integer hashCodeBinding) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        public boolean getBindingIsReadOnly() {
            return true;
        }
    }

    public class MyRemainingBinding extends IntegerPropertyBindingPath<R> {
        private static final long serialVersionUID = 1L;
        @Override
        public String getName() {
            return "remaining";
        }
        @Override
        public Binding<?> getParentBinding() {
            return StringPropertyBindingPath.this;
        }
        @Override
        public IntegerProperty get() {
            return StringPropertyBindingPath.this.get().remaining();
        }
        @Override
        public IntegerProperty getWithRoot(R root) {
            return StringPropertyBindingPath.this.getWithRoot(root).remaining();
        }
        @Override
        public IntegerProperty getSafelyWithRoot(R root) {
            if (StringPropertyBindingPath.this.getSafelyWithRoot(root) == null) {
                return null;
            } else {
                return StringPropertyBindingPath.this.getWithRoot(root).remaining();
            }
        }
        @Override
        public void set(IntegerProperty remaining) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        @Override
        public void setWithRoot(R root, IntegerProperty remaining) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        public boolean getBindingIsReadOnly() {
            return true;
        }
    }

    public class MyMaxLengthBinding extends IntegerPropertyBindingPath<R> {
        private static final long serialVersionUID = 1L;
        @Override
        public String getName() {
            return "maxLength";
        }
        @Override
        public Binding<?> getParentBinding() {
            return StringPropertyBindingPath.this;
        }
        @Override
        public IntegerProperty get() {
            return StringPropertyBindingPath.this.get().maxLength();
        }
        @Override
        public IntegerProperty getWithRoot(R root) {
            return StringPropertyBindingPath.this.getWithRoot(root).maxLength();
        }
        @Override
        public IntegerProperty getSafelyWithRoot(R root) {
            if (StringPropertyBindingPath.this.getSafelyWithRoot(root) == null) {
                return null;
            } else {
                return StringPropertyBindingPath.this.getWithRoot(root).maxLength();
            }
        }
        @Override
        public void set(IntegerProperty maxLength) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        @Override
        public void setWithRoot(R root, IntegerProperty maxLength) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        public boolean getBindingIsReadOnly() {
            return true;
        }
    }

    public class MyLengthBinding extends IntegerPropertyBindingPath<R> {
        private static final long serialVersionUID = 1L;
        @Override
        public String getName() {
            return "length";
        }
        @Override
        public Binding<?> getParentBinding() {
            return StringPropertyBindingPath.this;
        }
        @Override
        public IntegerProperty get() {
            return StringPropertyBindingPath.this.get().length();
        }
        @Override
        public IntegerProperty getWithRoot(R root) {
            return StringPropertyBindingPath.this.getWithRoot(root).length();
        }
        @Override
        public IntegerProperty getSafelyWithRoot(R root) {
            if (StringPropertyBindingPath.this.getSafelyWithRoot(root) == null) {
                return null;
            } else {
                return StringPropertyBindingPath.this.getWithRoot(root).length();
            }
        }
        @Override
        public void set(IntegerProperty length) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        @Override
        public void setWithRoot(R root, IntegerProperty length) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        public boolean getBindingIsReadOnly() {
            return true;
        }
    }

    public class MyGetBindingBinding extends GenericObjectBindingPath<R,String> {
        private static final long serialVersionUID = 1L;
        public Class<?> getType() {
            return java.lang.String.class;
        }
        @Override
        public String getName() {
            return "getBinding";
        }
        @Override
        public Binding<?> getParentBinding() {
            return StringPropertyBindingPath.this;
        }
        @Override
        public String get() {
            return StringPropertyBindingPath.this.get().get();
        }
        @Override
        public String getWithRoot(R root) {
            return StringPropertyBindingPath.this.getWithRoot(root).get();
        }
        @Override
        public String getSafelyWithRoot(R root) {
            if (StringPropertyBindingPath.this.getSafelyWithRoot(root) == null) {
                return null;
            } else {
                return StringPropertyBindingPath.this.getWithRoot(root).get();
            }
        }
        @Override
        public void set(String getBinding) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        @Override
        public void setWithRoot(R root, String getBinding) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        public boolean getBindingIsReadOnly() {
            return true;
        }
    }

    public class MyTouchBinding extends ValidBindingPath<R> {
        private static final long serialVersionUID = 1L;
        @Override
        public String getName() {
            return "touch";
        }
        @Override
        public Binding<?> getParentBinding() {
            return StringPropertyBindingPath.this;
        }
        @Override
        public Valid get() {
            return StringPropertyBindingPath.this.get().touch();
        }
        @Override
        public Valid getWithRoot(R root) {
            return StringPropertyBindingPath.this.getWithRoot(root).touch();
        }
        @Override
        public Valid getSafelyWithRoot(R root) {
            if (StringPropertyBindingPath.this.getSafelyWithRoot(root) == null) {
                return null;
            } else {
                return StringPropertyBindingPath.this.getWithRoot(root).touch();
            }
        }
        @Override
        public void set(Valid touch) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        @Override
        public void setWithRoot(R root, Valid touch) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        public boolean getBindingIsReadOnly() {
            return true;
        }
    }

    public class MyToStringBindingBinding extends GenericObjectBindingPath<R,String> {
        private static final long serialVersionUID = 1L;
        public Class<?> getType() {
            return java.lang.String.class;
        }
        @Override
        public String getName() {
            return "toStringBinding";
        }
        @Override
        public Binding<?> getParentBinding() {
            return StringPropertyBindingPath.this;
        }
        @Override
        public String get() {
            return StringPropertyBindingPath.this.get().toString();
        }
        @Override
        public String getWithRoot(R root) {
            return StringPropertyBindingPath.this.getWithRoot(root).toString();
        }
        @Override
        public String getSafelyWithRoot(R root) {
            if (StringPropertyBindingPath.this.getSafelyWithRoot(root) == null) {
                return null;
            } else {
                return StringPropertyBindingPath.this.getWithRoot(root).toString();
            }
        }
        @Override
        public void set(String toStringBinding) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        @Override
        public void setWithRoot(R root, String toStringBinding) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        public boolean getBindingIsReadOnly() {
            return true;
        }
    }

    public class MyReqBinding extends StringPropertyBindingPath<R> {
        private static final long serialVersionUID = 1L;
        @Override
        public String getName() {
            return "req";
        }
        @Override
        public Binding<?> getParentBinding() {
            return StringPropertyBindingPath.this;
        }
        @Override
        public StringProperty get() {
            return StringPropertyBindingPath.this.get().req();
        }
        @Override
        public StringProperty getWithRoot(R root) {
            return StringPropertyBindingPath.this.getWithRoot(root).req();
        }
        @Override
        public StringProperty getSafelyWithRoot(R root) {
            if (StringPropertyBindingPath.this.getSafelyWithRoot(root) == null) {
                return null;
            } else {
                return StringPropertyBindingPath.this.getWithRoot(root).req();
            }
        }
        @Override
        public void set(StringProperty req) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        @Override
        public void setWithRoot(R root, StringProperty req) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        public boolean getBindingIsReadOnly() {
            return true;
        }
    }

    public class MyReassessBinding implements Runnable, NamedBinding {
        private static final long serialVersionUID = 1L;
        public void run() {
            StringPropertyBindingPath.this.get().reassess();
        }
        public String getName() {
            return "reassess";
        }
    }

    public class MyValueBinding extends ValueBindingPath<R, String> {
        private static final long serialVersionUID = 1L;
        @Override
        public String getName() {
            return "value";
        }
        @Override
        public Binding<?> getParentBinding() {
            return StringPropertyBindingPath.this;
        }
        @Override
        public Value<String> get() {
            return StringPropertyBindingPath.this.get().getValue();
        }
        @Override
        public Value<String> getWithRoot(R root) {
            return StringPropertyBindingPath.this.getWithRoot(root).getValue();
        }
        @Override
        public Value<String> getSafelyWithRoot(R root) {
            if (StringPropertyBindingPath.this.getSafelyWithRoot(root) == null) {
                return null;
            } else {
                return StringPropertyBindingPath.this.getWithRoot(root).getValue();
            }
        }
        @Override
        public void set(Value<String> value) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        @Override
        public void setWithRoot(R root, Value<String> value) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        public boolean getBindingIsReadOnly() {
            return true;
        }
    }

    public class MyGetRemainingBinding extends GenericObjectBindingPath<R,Integer> {
        private static final long serialVersionUID = 1L;
        public Class<?> getType() {
            return java.lang.Integer.class;
        }
        @Override
        public String getName() {
            return "getRemaining";
        }
        @Override
        public Binding<?> getParentBinding() {
            return StringPropertyBindingPath.this;
        }
        @Override
        public Integer get() {
            return StringPropertyBindingPath.this.get().getRemaining();
        }
        @Override
        public Integer getWithRoot(R root) {
            return StringPropertyBindingPath.this.getWithRoot(root).getRemaining();
        }
        @Override
        public Integer getSafelyWithRoot(R root) {
            if (StringPropertyBindingPath.this.getSafelyWithRoot(root) == null) {
                return null;
            } else {
                return StringPropertyBindingPath.this.getWithRoot(root).getRemaining();
            }
        }
        @Override
        public void set(Integer getRemaining) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        @Override
        public void setWithRoot(R root, Integer getRemaining) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        public boolean getBindingIsReadOnly() {
            return true;
        }
    }

    public class MyGetMaxLengthBinding extends GenericObjectBindingPath<R,Integer> {
        private static final long serialVersionUID = 1L;
        public Class<?> getType() {
            return java.lang.Integer.class;
        }
        @Override
        public String getName() {
            return "getMaxLength";
        }
        @Override
        public Binding<?> getParentBinding() {
            return StringPropertyBindingPath.this;
        }
        @Override
        public Integer get() {
            return StringPropertyBindingPath.this.get().getMaxLength();
        }
        @Override
        public Integer getWithRoot(R root) {
            return StringPropertyBindingPath.this.getWithRoot(root).getMaxLength();
        }
        @Override
        public Integer getSafelyWithRoot(R root) {
            if (StringPropertyBindingPath.this.getSafelyWithRoot(root) == null) {
                return null;
            } else {
                return StringPropertyBindingPath.this.getWithRoot(root).getMaxLength();
            }
        }
        @Override
        public void set(Integer getMaxLength) {
            StringPropertyBindingPath.this.get().setMaxLength(getMaxLength);
        }
        @Override
        public void setWithRoot(R root, Integer getMaxLength) {
            StringPropertyBindingPath.this.getWithRoot(root).setMaxLength(getMaxLength);
        }
    }

    public class MyErrorsBinding extends GenericObjectBindingPath<R,Map<Object,String>> {
        private static final long serialVersionUID = 1L;
        public Class<?> getType() {
            return java.util.Map.class;
        }
        @Override
        public String getName() {
            return "errors";
        }
        @Override
        public Binding<?> getParentBinding() {
            return StringPropertyBindingPath.this;
        }
        @Override
        public Map<Object,String> get() {
            return StringPropertyBindingPath.this.get().getErrors();
        }
        @Override
        public Map<Object,String> getWithRoot(R root) {
            return StringPropertyBindingPath.this.getWithRoot(root).getErrors();
        }
        @Override
        public Map<Object,String> getSafelyWithRoot(R root) {
            if (StringPropertyBindingPath.this.getSafelyWithRoot(root) == null) {
                return null;
            } else {
                return StringPropertyBindingPath.this.getWithRoot(root).getErrors();
            }
        }
        @Override
        public void set(Map<Object,String> errors) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        @Override
        public void setWithRoot(R root, Map<Object,String> errors) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        public boolean getBindingIsReadOnly() {
            return true;
        }
    }

    public class MyNameBinding extends GenericObjectBindingPath<R,String> {
        private static final long serialVersionUID = 1L;
        public Class<?> getType() {
            return java.lang.String.class;
        }
        @Override
        public String getName() {
            return "name";
        }
        @Override
        public Binding<?> getParentBinding() {
            return StringPropertyBindingPath.this;
        }
        @Override
        public String get() {
            return StringPropertyBindingPath.this.get().getName();
        }
        @Override
        public String getWithRoot(R root) {
            return StringPropertyBindingPath.this.getWithRoot(root).getName();
        }
        @Override
        public String getSafelyWithRoot(R root) {
            if (StringPropertyBindingPath.this.getSafelyWithRoot(root) == null) {
                return null;
            } else {
                return StringPropertyBindingPath.this.getWithRoot(root).getName();
            }
        }
        @Override
        public void set(String name) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        @Override
        public void setWithRoot(R root, String name) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        public boolean getBindingIsReadOnly() {
            return true;
        }
    }

    protected class MyGetThisBinding extends StringPropertyBindingPath<R> {
        private static final long serialVersionUID = 1L;
        @Override
        public String getName() {
            return "getThis";
        }
        @Override
        public Binding<?> getParentBinding() {
            return StringPropertyBindingPath.this;
        }
        @Override
        public StringProperty get() {
            return StringPropertyBindingPath.this.get().getThis();
        }
        @Override
        public StringProperty getWithRoot(R root) {
            return StringPropertyBindingPath.this.getWithRoot(root).getThis();
        }
        @Override
        public StringProperty getSafelyWithRoot(R root) {
            if (StringPropertyBindingPath.this.getSafelyWithRoot(root) == null) {
                return null;
            } else {
                return StringPropertyBindingPath.this.getWithRoot(root).getThis();
            }
        }
        @Override
        public void set(StringProperty getThis) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        @Override
        public void setWithRoot(R root, StringProperty getThis) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        public boolean getBindingIsReadOnly() {
            return true;
        }
    }

    public class MyGetLengthBinding extends GenericObjectBindingPath<R,Integer> {
        private static final long serialVersionUID = 1L;
        public Class<?> getType() {
            return java.lang.Integer.class;
        }
        @Override
        public String getName() {
            return "getLength";
        }
        @Override
        public Binding<?> getParentBinding() {
            return StringPropertyBindingPath.this;
        }
        @Override
        public Integer get() {
            return StringPropertyBindingPath.this.get().getLength();
        }
        @Override
        public Integer getWithRoot(R root) {
            return StringPropertyBindingPath.this.getWithRoot(root).getLength();
        }
        @Override
        public Integer getSafelyWithRoot(R root) {
            if (StringPropertyBindingPath.this.getSafelyWithRoot(root) == null) {
                return null;
            } else {
                return StringPropertyBindingPath.this.getWithRoot(root).getLength();
            }
        }
        @Override
        public void set(Integer getLength) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        @Override
        public void setWithRoot(R root, Integer getLength) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        public boolean getBindingIsReadOnly() {
            return true;
        }
    }

    public class MyReadOnlyBinding extends GenericObjectBindingPath<R,Boolean> {
        private static final long serialVersionUID = 1L;
        public Class<?> getType() {
            return java.lang.Boolean.class;
        }
        @Override
        public String getName() {
            return "readOnly";
        }
        @Override
        public Binding<?> getParentBinding() {
            return StringPropertyBindingPath.this;
        }
        @Override
        public Boolean get() {
            return StringPropertyBindingPath.this.get().isReadOnly();
        }
        @Override
        public Boolean getWithRoot(R root) {
            return StringPropertyBindingPath.this.getWithRoot(root).isReadOnly();
        }
        @Override
        public Boolean getSafelyWithRoot(R root) {
            if (StringPropertyBindingPath.this.getSafelyWithRoot(root) == null) {
                return null;
            } else {
                return StringPropertyBindingPath.this.getWithRoot(root).isReadOnly();
            }
        }
        @Override
        public void set(Boolean readOnly) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        @Override
        public void setWithRoot(R root, Boolean readOnly) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        public boolean getBindingIsReadOnly() {
            return true;
        }
    }

    public class MyTouchedBinding extends GenericObjectBindingPath<R,Boolean> {
        private static final long serialVersionUID = 1L;
        public Class<?> getType() {
            return java.lang.Boolean.class;
        }
        @Override
        public String getName() {
            return "touched";
        }
        @Override
        public Binding<?> getParentBinding() {
            return StringPropertyBindingPath.this;
        }
        @Override
        public Boolean get() {
            return StringPropertyBindingPath.this.get().isTouched();
        }
        @Override
        public Boolean getWithRoot(R root) {
            return StringPropertyBindingPath.this.getWithRoot(root).isTouched();
        }
        @Override
        public Boolean getSafelyWithRoot(R root) {
            if (StringPropertyBindingPath.this.getSafelyWithRoot(root) == null) {
                return null;
            } else {
                return StringPropertyBindingPath.this.getWithRoot(root).isTouched();
            }
        }
        @Override
        public void set(Boolean touched) {
            StringPropertyBindingPath.this.get().setTouched(touched);
        }
        @Override
        public void setWithRoot(R root, Boolean touched) {
            StringPropertyBindingPath.this.getWithRoot(root).setTouched(touched);
        }
    }

    protected class MyDerivedBinding extends GenericObjectBindingPath<R,ArrayList<Property<?>>> {
        private static final long serialVersionUID = 1L;
        public Class<?> getType() {
            return java.util.ArrayList.class;
        }
        @Override
        public String getName() {
            return "derived";
        }
        @Override
        public Binding<?> getParentBinding() {
            return StringPropertyBindingPath.this;
        }
        @Override
        public ArrayList<Property<?>> get() {
            return StringPropertyBindingPath.this.get().derived;
        }
        @Override
        public ArrayList<Property<?>> getWithRoot(R root) {
            return StringPropertyBindingPath.this.getWithRoot(root).derived;
        }
        @Override
        public ArrayList<Property<?>> getSafelyWithRoot(R root) {
            if (StringPropertyBindingPath.this.getSafelyWithRoot(root) == null) {
                return null;
            } else {
                return StringPropertyBindingPath.this.getSafelyWithRoot(root).derived;
            }
        }
        @Override
        public void set(ArrayList<Property<?>> derived) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        @Override
        public void setWithRoot(R root, ArrayList<Property<?>> derived) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        public boolean getBindingIsReadOnly() {
            return true;
        }
    }

}
