package org.gwtmpv.model.validation;

import java.util.List;
import org.bindgen.Binding;
import org.bindgen.binding.AbstractBinding;
import org.bindgen.binding.GenericObjectBindingPath;

@SuppressWarnings("all")
public abstract class ValidBindingPath<R> extends AbstractBinding<R, Valid> {

    private GenericObjectBindingPath<R,Integer> hashCodeBinding;
    private GenericObjectBindingPath<R,Integer> ordinal;
    private GenericObjectBindingPath<R,String> name;
    private GenericObjectBindingPath<R,String> toStringBinding;
    private static final long serialVersionUID = 1L;

    @Override
    public String getName() {
        return "";
    }

    @Override
    public Class<?> getType() {
        return org.gwtmpv.model.validation.Valid.class;
    }

    public GenericObjectBindingPath<R,Integer> hashCodeBinding() {
        if (this.hashCodeBinding == null) {
            this.hashCodeBinding = new MyHashCodeBindingBinding();
        }
        return this.hashCodeBinding;
    }

    public GenericObjectBindingPath<R,Integer> ordinal() {
        if (this.ordinal == null) {
            this.ordinal = new MyOrdinalBinding();
        }
        return this.ordinal;
    }

    public GenericObjectBindingPath<R,String> name() {
        if (this.name == null) {
            this.name = new MyNameBinding();
        }
        return this.name;
    }

    public GenericObjectBindingPath<R,String> toStringBinding() {
        if (this.toStringBinding == null) {
            this.toStringBinding = new MyToStringBindingBinding();
        }
        return this.toStringBinding;
    }

    @Override
    public List<Binding<?>> getChildBindings() {
        List<Binding<?>> bindings = new java.util.ArrayList<Binding<?>>();
        bindings.add(this.hashCodeBinding());
        bindings.add(this.ordinal());
        bindings.add(this.name());
        bindings.add(this.toStringBinding());
        return bindings;
    }

    public class MyHashCodeBindingBinding extends GenericObjectBindingPath<R,Integer> {
        private static final long serialVersionUID = 1L;
        public Class<?> getType() {
            return java.lang.Integer.class;
        }
        @Override
        public String getName() {
            return "hashCodeBinding";
        }
        @Override
        public Binding<?> getParentBinding() {
            return ValidBindingPath.this;
        }
        @Override
        public Integer get() {
            return ValidBindingPath.this.get().hashCode();
        }
        @Override
        public Integer getWithRoot(R root) {
            return ValidBindingPath.this.getWithRoot(root).hashCode();
        }
        @Override
        public Integer getSafelyWithRoot(R root) {
            if (ValidBindingPath.this.getSafelyWithRoot(root) == null) {
                return null;
            } else {
                return ValidBindingPath.this.getWithRoot(root).hashCode();
            }
        }
        @Override
        public void set(Integer hashCodeBinding) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        @Override
        public void setWithRoot(R root, Integer hashCodeBinding) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        public boolean getBindingIsReadOnly() {
            return true;
        }
    }

    public class MyOrdinalBinding extends GenericObjectBindingPath<R,Integer> {
        private static final long serialVersionUID = 1L;
        public Class<?> getType() {
            return java.lang.Integer.class;
        }
        @Override
        public String getName() {
            return "ordinal";
        }
        @Override
        public Binding<?> getParentBinding() {
            return ValidBindingPath.this;
        }
        @Override
        public Integer get() {
            return ValidBindingPath.this.get().ordinal();
        }
        @Override
        public Integer getWithRoot(R root) {
            return ValidBindingPath.this.getWithRoot(root).ordinal();
        }
        @Override
        public Integer getSafelyWithRoot(R root) {
            if (ValidBindingPath.this.getSafelyWithRoot(root) == null) {
                return null;
            } else {
                return ValidBindingPath.this.getWithRoot(root).ordinal();
            }
        }
        @Override
        public void set(Integer ordinal) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        @Override
        public void setWithRoot(R root, Integer ordinal) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        public boolean getBindingIsReadOnly() {
            return true;
        }
    }

    public class MyNameBinding extends GenericObjectBindingPath<R,String> {
        private static final long serialVersionUID = 1L;
        public Class<?> getType() {
            return java.lang.String.class;
        }
        @Override
        public String getName() {
            return "name";
        }
        @Override
        public Binding<?> getParentBinding() {
            return ValidBindingPath.this;
        }
        @Override
        public String get() {
            return ValidBindingPath.this.get().name();
        }
        @Override
        public String getWithRoot(R root) {
            return ValidBindingPath.this.getWithRoot(root).name();
        }
        @Override
        public String getSafelyWithRoot(R root) {
            if (ValidBindingPath.this.getSafelyWithRoot(root) == null) {
                return null;
            } else {
                return ValidBindingPath.this.getWithRoot(root).name();
            }
        }
        @Override
        public void set(String name) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        @Override
        public void setWithRoot(R root, String name) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        public boolean getBindingIsReadOnly() {
            return true;
        }
    }

    public class MyToStringBindingBinding extends GenericObjectBindingPath<R,String> {
        private static final long serialVersionUID = 1L;
        public Class<?> getType() {
            return java.lang.String.class;
        }
        @Override
        public String getName() {
            return "toStringBinding";
        }
        @Override
        public Binding<?> getParentBinding() {
            return ValidBindingPath.this;
        }
        @Override
        public String get() {
            return ValidBindingPath.this.get().toString();
        }
        @Override
        public String getWithRoot(R root) {
            return ValidBindingPath.this.getWithRoot(root).toString();
        }
        @Override
        public String getSafelyWithRoot(R root) {
            if (ValidBindingPath.this.getSafelyWithRoot(root) == null) {
                return null;
            } else {
                return ValidBindingPath.this.getWithRoot(root).toString();
            }
        }
        @Override
        public void set(String toStringBinding) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        @Override
        public void setWithRoot(R root, String toStringBinding) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        public boolean getBindingIsReadOnly() {
            return true;
        }
    }

}
