package org.gwtmpv.model.values;

import java.util.List;
import org.bindgen.Binding;
import org.bindgen.binding.AbstractBinding;
import org.bindgen.binding.GenericObjectBindingPath;

@SuppressWarnings("all")
public abstract class ValueBindingPath<R, P> extends AbstractBinding<R, Value<P>> {

    private AbstractBinding<R, P> getBinding;
    private GenericObjectBindingPath<R,Integer> hashCodeBinding;
    private GenericObjectBindingPath<R,String> toStringBinding;
    private GenericObjectBindingPath<R,String> name;
    private GenericObjectBindingPath<R,Boolean> readOnly;
    private static final long serialVersionUID = 1L;

    @Override
    public String getName() {
        return "";
    }

    @Override
    public Class<?> getType() {
        return org.gwtmpv.model.values.Value.class;
    }

    public AbstractBinding<R, P> getBinding() {
        if (this.getBinding == null) {
            this.getBinding = new MyGetBindingBinding();
        }
        return this.getBinding;
    }

    public GenericObjectBindingPath<R,Integer> hashCodeBinding() {
        if (this.hashCodeBinding == null) {
            this.hashCodeBinding = new MyHashCodeBindingBinding();
        }
        return this.hashCodeBinding;
    }

    public GenericObjectBindingPath<R,String> toStringBinding() {
        if (this.toStringBinding == null) {
            this.toStringBinding = new MyToStringBindingBinding();
        }
        return this.toStringBinding;
    }

    public GenericObjectBindingPath<R,String> name() {
        if (this.name == null) {
            this.name = new MyNameBinding();
        }
        return this.name;
    }

    public GenericObjectBindingPath<R,Boolean> readOnly() {
        if (this.readOnly == null) {
            this.readOnly = new MyReadOnlyBinding();
        }
        return this.readOnly;
    }

    @Override
    public List<Binding<?>> getChildBindings() {
        List<Binding<?>> bindings = new java.util.ArrayList<Binding<?>>();
        bindings.add(this.getBinding());
        bindings.add(this.hashCodeBinding());
        bindings.add(this.toStringBinding());
        bindings.add(this.name());
        bindings.add(this.readOnly());
        return bindings;
    }

    public class MyGetBindingBinding extends AbstractBinding<R, P> {
        private static final long serialVersionUID = 1L;
        public Class<?> getType() {
            return null;
        }
        @Override
        public String getName() {
            return "getBinding";
        }
        @Override
        public Binding<?> getParentBinding() {
            return ValueBindingPath.this;
        }
        @Override
        public P get() {
            return ValueBindingPath.this.get().get();
        }
        @Override
        public P getWithRoot(R root) {
            return ValueBindingPath.this.getWithRoot(root).get();
        }
        @Override
        public P getSafelyWithRoot(R root) {
            if (ValueBindingPath.this.getSafelyWithRoot(root) == null) {
                return null;
            } else {
                return ValueBindingPath.this.getWithRoot(root).get();
            }
        }
        @Override
        public void set(P getBinding) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        @Override
        public void setWithRoot(R root, P getBinding) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        public boolean getBindingIsReadOnly() {
            return true;
        }
    }

    public class MyHashCodeBindingBinding extends GenericObjectBindingPath<R,Integer> {
        private static final long serialVersionUID = 1L;
        public Class<?> getType() {
            return java.lang.Integer.class;
        }
        @Override
        public String getName() {
            return "hashCodeBinding";
        }
        @Override
        public Binding<?> getParentBinding() {
            return ValueBindingPath.this;
        }
        @Override
        public Integer get() {
            return ValueBindingPath.this.get().hashCode();
        }
        @Override
        public Integer getWithRoot(R root) {
            return ValueBindingPath.this.getWithRoot(root).hashCode();
        }
        @Override
        public Integer getSafelyWithRoot(R root) {
            if (ValueBindingPath.this.getSafelyWithRoot(root) == null) {
                return null;
            } else {
                return ValueBindingPath.this.getWithRoot(root).hashCode();
            }
        }
        @Override
        public void set(Integer hashCodeBinding) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        @Override
        public void setWithRoot(R root, Integer hashCodeBinding) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        public boolean getBindingIsReadOnly() {
            return true;
        }
    }

    public class MyToStringBindingBinding extends GenericObjectBindingPath<R,String> {
        private static final long serialVersionUID = 1L;
        public Class<?> getType() {
            return java.lang.String.class;
        }
        @Override
        public String getName() {
            return "toStringBinding";
        }
        @Override
        public Binding<?> getParentBinding() {
            return ValueBindingPath.this;
        }
        @Override
        public String get() {
            return ValueBindingPath.this.get().toString();
        }
        @Override
        public String getWithRoot(R root) {
            return ValueBindingPath.this.getWithRoot(root).toString();
        }
        @Override
        public String getSafelyWithRoot(R root) {
            if (ValueBindingPath.this.getSafelyWithRoot(root) == null) {
                return null;
            } else {
                return ValueBindingPath.this.getWithRoot(root).toString();
            }
        }
        @Override
        public void set(String toStringBinding) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        @Override
        public void setWithRoot(R root, String toStringBinding) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        public boolean getBindingIsReadOnly() {
            return true;
        }
    }

    public class MyNameBinding extends GenericObjectBindingPath<R,String> {
        private static final long serialVersionUID = 1L;
        public Class<?> getType() {
            return java.lang.String.class;
        }
        @Override
        public String getName() {
            return "name";
        }
        @Override
        public Binding<?> getParentBinding() {
            return ValueBindingPath.this;
        }
        @Override
        public String get() {
            return ValueBindingPath.this.get().getName();
        }
        @Override
        public String getWithRoot(R root) {
            return ValueBindingPath.this.getWithRoot(root).getName();
        }
        @Override
        public String getSafelyWithRoot(R root) {
            if (ValueBindingPath.this.getSafelyWithRoot(root) == null) {
                return null;
            } else {
                return ValueBindingPath.this.getWithRoot(root).getName();
            }
        }
        @Override
        public void set(String name) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        @Override
        public void setWithRoot(R root, String name) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        public boolean getBindingIsReadOnly() {
            return true;
        }
    }

    public class MyReadOnlyBinding extends GenericObjectBindingPath<R,Boolean> {
        private static final long serialVersionUID = 1L;
        public Class<?> getType() {
            return java.lang.Boolean.class;
        }
        @Override
        public String getName() {
            return "readOnly";
        }
        @Override
        public Binding<?> getParentBinding() {
            return ValueBindingPath.this;
        }
        @Override
        public Boolean get() {
            return ValueBindingPath.this.get().isReadOnly();
        }
        @Override
        public Boolean getWithRoot(R root) {
            return ValueBindingPath.this.getWithRoot(root).isReadOnly();
        }
        @Override
        public Boolean getSafelyWithRoot(R root) {
            if (ValueBindingPath.this.getSafelyWithRoot(root) == null) {
                return null;
            } else {
                return ValueBindingPath.this.getWithRoot(root).isReadOnly();
            }
        }
        @Override
        public void set(Boolean readOnly) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        @Override
        public void setWithRoot(R root, Boolean readOnly) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        public boolean getBindingIsReadOnly() {
            return true;
        }
    }

}
