package org.gwtmpv.tests.model.properties.dtoListPropertyTest;

import java.util.List;
import org.bindgen.Binding;
import org.bindgen.binding.AbstractBinding;
import org.bindgen.binding.GenericObjectBindingPath;
import org.gwtmpv.model.properties.Property;
import org.gwtmpv.model.properties.PropertyBindingPath;
import org.gwtmpv.model.properties.PropertyGroup;
import org.gwtmpv.model.properties.PropertyGroupBindingPath;
import org.gwtmpv.model.properties.StringProperty;
import org.gwtmpv.model.properties.StringPropertyBindingPath;
import org.gwtmpv.tests.model.properties.DtoListPropertyTest;

@SuppressWarnings("all")
public abstract class MBindingPath<R> extends AbstractBinding<R, DtoListPropertyTest.M> {

    private PropertyBindingPath<R, Boolean> allValid;
    private GenericObjectBindingPath<R,Integer> hashCodeBinding;
    private GenericObjectBindingPath<R,String> toStringBinding;
    private PropertyGroupBindingPath<R> all;
    private DBindingPath<R> dto;
    private StringPropertyBindingPath<R> name;
    private static final long serialVersionUID = 1L;

    @Override
    public String getName() {
        return "";
    }

    @Override
    public Class<?> getType() {
        return org.gwtmpv.tests.model.properties.DtoListPropertyTest.M.class;
    }

    public PropertyBindingPath<R, Boolean> allValid() {
        if (this.allValid == null) {
            this.allValid = new MyAllValidBinding();
        }
        return this.allValid;
    }

    public GenericObjectBindingPath<R,Integer> hashCodeBinding() {
        if (this.hashCodeBinding == null) {
            this.hashCodeBinding = new MyHashCodeBindingBinding();
        }
        return this.hashCodeBinding;
    }

    public GenericObjectBindingPath<R,String> toStringBinding() {
        if (this.toStringBinding == null) {
            this.toStringBinding = new MyToStringBindingBinding();
        }
        return this.toStringBinding;
    }

    public PropertyGroupBindingPath<R> all() {
        if (this.all == null) {
            this.all = new MyAllBinding();
        }
        return this.all;
    }

    public DBindingPath<R> dto() {
        if (this.dto == null) {
            this.dto = new MyDtoBinding();
        }
        return this.dto;
    }

    public StringPropertyBindingPath<R> name() {
        if (this.name == null) {
            this.name = new MyNameBinding();
        }
        return this.name;
    }

    @Override
    public List<Binding<?>> getChildBindings() {
        List<Binding<?>> bindings = new java.util.ArrayList<Binding<?>>();
        bindings.add(this.allValid());
        bindings.add(this.hashCodeBinding());
        bindings.add(this.toStringBinding());
        bindings.add(this.all());
        bindings.add(this.dto());
        bindings.add(this.name());
        return bindings;
    }

    public class MyAllValidBinding extends PropertyBindingPath<R, Boolean> {
        private static final long serialVersionUID = 1L;
        @Override
        public String getName() {
            return "allValid";
        }
        @Override
        public Binding<?> getParentBinding() {
            return MBindingPath.this;
        }
        @Override
        public Property<Boolean> get() {
            return MBindingPath.this.get().allValid();
        }
        @Override
        public Property<Boolean> getWithRoot(R root) {
            return MBindingPath.this.getWithRoot(root).allValid();
        }
        @Override
        public Property<Boolean> getSafelyWithRoot(R root) {
            if (MBindingPath.this.getSafelyWithRoot(root) == null) {
                return null;
            } else {
                return MBindingPath.this.getWithRoot(root).allValid();
            }
        }
        @Override
        public void set(Property<Boolean> allValid) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        @Override
        public void setWithRoot(R root, Property<Boolean> allValid) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        public boolean getBindingIsReadOnly() {
            return true;
        }
    }

    public class MyHashCodeBindingBinding extends GenericObjectBindingPath<R,Integer> {
        private static final long serialVersionUID = 1L;
        public Class<?> getType() {
            return java.lang.Integer.class;
        }
        @Override
        public String getName() {
            return "hashCodeBinding";
        }
        @Override
        public Binding<?> getParentBinding() {
            return MBindingPath.this;
        }
        @Override
        public Integer get() {
            return MBindingPath.this.get().hashCode();
        }
        @Override
        public Integer getWithRoot(R root) {
            return MBindingPath.this.getWithRoot(root).hashCode();
        }
        @Override
        public Integer getSafelyWithRoot(R root) {
            if (MBindingPath.this.getSafelyWithRoot(root) == null) {
                return null;
            } else {
                return MBindingPath.this.getWithRoot(root).hashCode();
            }
        }
        @Override
        public void set(Integer hashCodeBinding) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        @Override
        public void setWithRoot(R root, Integer hashCodeBinding) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        public boolean getBindingIsReadOnly() {
            return true;
        }
    }

    public class MyToStringBindingBinding extends GenericObjectBindingPath<R,String> {
        private static final long serialVersionUID = 1L;
        public Class<?> getType() {
            return java.lang.String.class;
        }
        @Override
        public String getName() {
            return "toStringBinding";
        }
        @Override
        public Binding<?> getParentBinding() {
            return MBindingPath.this;
        }
        @Override
        public String get() {
            return MBindingPath.this.get().toString();
        }
        @Override
        public String getWithRoot(R root) {
            return MBindingPath.this.getWithRoot(root).toString();
        }
        @Override
        public String getSafelyWithRoot(R root) {
            if (MBindingPath.this.getSafelyWithRoot(root) == null) {
                return null;
            } else {
                return MBindingPath.this.getWithRoot(root).toString();
            }
        }
        @Override
        public void set(String toStringBinding) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        @Override
        public void setWithRoot(R root, String toStringBinding) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        public boolean getBindingIsReadOnly() {
            return true;
        }
    }

    public class MyAllBinding extends PropertyGroupBindingPath<R> {
        private static final long serialVersionUID = 1L;
        @Override
        public String getName() {
            return "all";
        }
        @Override
        public Binding<?> getParentBinding() {
            return MBindingPath.this;
        }
        @Override
        public PropertyGroup get() {
            return MBindingPath.this.get().all();
        }
        @Override
        public PropertyGroup getWithRoot(R root) {
            return MBindingPath.this.getWithRoot(root).all();
        }
        @Override
        public PropertyGroup getSafelyWithRoot(R root) {
            if (MBindingPath.this.getSafelyWithRoot(root) == null) {
                return null;
            } else {
                return MBindingPath.this.getWithRoot(root).all();
            }
        }
        @Override
        public void set(PropertyGroup all) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        @Override
        public void setWithRoot(R root, PropertyGroup all) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        public boolean getBindingIsReadOnly() {
            return true;
        }
    }

    public class MyDtoBinding extends DBindingPath<R> {
        private static final long serialVersionUID = 1L;
        @Override
        public String getName() {
            return "dto";
        }
        @Override
        public Binding<?> getParentBinding() {
            return MBindingPath.this;
        }
        @Override
        public DtoListPropertyTest.D get() {
            return MBindingPath.this.get().getDto();
        }
        @Override
        public DtoListPropertyTest.D getWithRoot(R root) {
            return MBindingPath.this.getWithRoot(root).getDto();
        }
        @Override
        public DtoListPropertyTest.D getSafelyWithRoot(R root) {
            if (MBindingPath.this.getSafelyWithRoot(root) == null) {
                return null;
            } else {
                return MBindingPath.this.getWithRoot(root).getDto();
            }
        }
        @Override
        public void set(DtoListPropertyTest.D dto) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        @Override
        public void setWithRoot(R root, DtoListPropertyTest.D dto) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        public boolean getBindingIsReadOnly() {
            return true;
        }
    }

    public class MyNameBinding extends StringPropertyBindingPath<R> {
        private static final long serialVersionUID = 1L;
        @Override
        public String getName() {
            return "name";
        }
        @Override
        public Binding<?> getParentBinding() {
            return MBindingPath.this;
        }
        @Override
        public StringProperty get() {
            return MBindingPath.this.get().name;
        }
        @Override
        public StringProperty getWithRoot(R root) {
            return MBindingPath.this.getWithRoot(root).name;
        }
        @Override
        public StringProperty getSafelyWithRoot(R root) {
            if (MBindingPath.this.getSafelyWithRoot(root) == null) {
                return null;
            } else {
                return MBindingPath.this.getSafelyWithRoot(root).name;
            }
        }
        @Override
        public void set(StringProperty name) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        @Override
        public void setWithRoot(R root, StringProperty name) {
            throw new RuntimeException(this.getName() + " is read only");
        }
        public boolean getBindingIsReadOnly() {
            return true;
        }
    }

}
